add.hpp File Reference
`#include <msgpack/preprocessor/arithmetic/dec.hpp>`
`#include <msgpack/preprocessor/arithmetic/inc.hpp>`
`#include <msgpack/preprocessor/config/config.hpp>`
`#include <msgpack/preprocessor/control/while.hpp>`
`#include <msgpack/preprocessor/tuple/elem.hpp>`

Go to the source code of this file.

## Macros

#define | MSGPACK_PP_ADD(x, y) MSGPACK_PP_ADD_I(x, y)
#define | MSGPACK_PP_ADD_I(x, y) MSGPACK_PP_TUPLE_ELEM(2, 0, MSGPACK_PP_WHILE(MSGPACK_PP_ADD_P, MSGPACK_PP_ADD_O, (x, y)))
#define | MSGPACK_PP_ADD_P(d, xy) MSGPACK_PP_TUPLE_ELEM(2, 1, xy)
#define | MSGPACK_PP_ADD_O(d, xy) MSGPACK_PP_ADD_O_I(MSGPACK_PP_TUPLE_ELEM(2, 0, xy), MSGPACK_PP_TUPLE_ELEM(2, 1, xy))
#define | MSGPACK_PP_ADD_O_I(x, y) (MSGPACK_PP_INC(x), MSGPACK_PP_DEC(y))
#define | MSGPACK_PP_ADD_D(d, x, y) MSGPACK_PP_ADD_D_I(d, x, y)
#define | MSGPACK_PP_ADD_D_I(d, x, y) MSGPACK_PP_TUPLE_ELEM(2, 0, MSGPACK_PP_WHILE_ ## d(MSGPACK_PP_ADD_P, MSGPACK_PP_ADD_O, (x, y)))

## Macro Definition Documentation

## MSGPACK_PP_ADD

#define MSGPACK_PP_ADD | ( |  | x,
|  |  | y
| ) |  | MSGPACK_PP_ADD_I(x, y)

## MSGPACK_PP_ADD_D

#define MSGPACK_PP_ADD_D | ( |  | d,
|  |  | x,
|  |  | y
| ) |  | MSGPACK_PP_ADD_D_I(d, x, y)

## MSGPACK_PP_ADD_D_I

#define MSGPACK_PP_ADD_D_I | ( |  | d,
|  |  | x,
|  |  | y
| ) |  | MSGPACK_PP_TUPLE_ELEM(2, 0, MSGPACK_PP_WHILE_ ## d(MSGPACK_PP_ADD_P, MSGPACK_PP_ADD_O, (x, y)))

## MSGPACK_PP_ADD_I

#define MSGPACK_PP_ADD_I | ( |  | x,
|  |  | y
| ) |  | MSGPACK_PP_TUPLE_ELEM(2, 0, MSGPACK_PP_WHILE(MSGPACK_PP_ADD_P, MSGPACK_PP_ADD_O, (x, y)))

## MSGPACK_PP_ADD_O

#define MSGPACK_PP_ADD_O | ( |  | d,
|  |  | xy
| ) |  | MSGPACK_PP_ADD_O_I(MSGPACK_PP_TUPLE_ELEM(2, 0, xy), MSGPACK_PP_TUPLE_ELEM(2, 1, xy))

## MSGPACK_PP_ADD_O_I

#define MSGPACK_PP_ADD_O_I | ( |  | x,
|  |  | y
| ) |  | (MSGPACK_PP_INC(x), MSGPACK_PP_DEC(y))

## MSGPACK_PP_ADD_P

#define MSGPACK_PP_ADD_P | ( |  | d,
|  |  | xy
| ) |  | MSGPACK_PP_TUPLE_ELEM(2, 1, xy)